"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.storageDeposit = exports.storageBalanceOf = exports.NEAR_DECIMALS = void 0;
const bn_js_1 = __importDefault(require("bn.js"));
const utils_1 = require("@tonic-foundation/utils");
__exportStar(require("./types"), exports);
exports.NEAR_DECIMALS = 24;
const ONE_TGAS = new bn_js_1.default('1000000000000');
const DEFAULT_GAS = ONE_TGAS.mul(new bn_js_1.default(100));
function toBnStorageBalance(balance) {
    return {
        available: new bn_js_1.default(balance.available),
        total: new bn_js_1.default(balance.total),
    };
}
function storageBalanceOf(account, contractId, accountId) {
    return __awaiter(this, void 0, void 0, function* () {
        const account_id = accountId || account.accountId;
        const balance = yield account.viewFunction(contractId, 'storage_balance_of', {
            account_id,
        });
        return balance ? toBnStorageBalance(balance) : null;
    });
}
exports.storageBalanceOf = storageBalanceOf;
/**
 * Deposit storage balance
 *
 * @param account Account to call with
 * @param contractId Contract to deposit into
 * @param args
 * @param gas Gas allowance, defaults to 100TGas
 */
function storageDeposit(account, contractId, args, gas = DEFAULT_GAS) {
    return __awaiter(this, void 0, void 0, function* () {
        const attachedDeposit = typeof args.amount === 'number'
            ? (0, utils_1.decimalToBn)(args.amount, exports.NEAR_DECIMALS)
            : args.amount;
        const account_id = args.accountId || account.accountId;
        const { executionOutcome, response: balance } = yield (0, utils_1.functionCallWithOutcome)(account, {
            contractId,
            methodName: 'storage_deposit',
            args: {
                account_id,
                registration_only: args.registrationOnly,
            },
            gas,
            attachedDeposit,
        });
        if (!balance) {
            throw new Error('Error depositing storage');
        }
        return {
            executionOutcome,
            result: toBnStorageBalance(balance),
        };
    });
}
exports.storageDeposit = storageDeposit;
